//--------------------------------------------------------------------------------//
//-                   HemiOs ( Hemisson Operating System )                       -//
//-																							         -//
//-  Ici un exemple avec le module dtecteur Ultrason                            -//
//-  Le robot s'approche d'un objet  ralentissant progrssivement  partir de   -//
//-  50cm et s'arrte  20cm. 														         -//
//-																							         -//
//- DIDASTEL Provence - Octobre 2003                                             -//
//-																							         -//
//--------------------------------------------------------------------------------//


// Placer le fichier "hemultrasonicsensor.h" dans le rpertoire de votre projet et ajouter
#include "hemultrasonicsensor.h"
// dans le fichier "main.c" de ce projet.

// Mettre le contenu de cette fonction dans la fonction "main()" de votre projet ...
void ExempleUS(void)
{
unsigned int16 ValUS;   // Entier sur 2 octets
signed int8 Moteur = 0;     // Entier sur 1 octet

   // Initialisation du Hemisson
   hemisson_init();

   // On arrte ci-dessous tous les fonctionnements par dfaut inutiles
   // Arrt de la lecture automatique des capteurs Infrarouges
	hemisson_config_auto_refresh_sensors(MANUAL);
   // Arrt de la lecture automatique de la tlcommande TV
	hemisson_config_auto_refresh_tv_remote(DISABLE);
   // Arrt de la gestion par RS232 du robot
   hemisson_config_rs232_control(DISABLE);
   // Arrt de la gestion par tlcommande du robot
	hemisson_config_tv_remote_control(DISABLE);

   // Initialisation module, attente apres la mise sous tension du robot
	HemUltraSon_Init();

   // On teste la presence du module US sinon on sonne 2s
   if (HemUltraSon_Read_Version() != 255)
      {
      // OK module oprationnel
      while(1)
         {
         // lance une mesure en centimtres
         HemUltraSon_Start_Measure();

         // Lecture du 1er echo, le 1er echo dtecte le sol  80 cm environ
         ValUS = HemUltraSon_Read_Values(0x00);
         if (ValUS > 50)         // 50 cm
            Moteur = 9;          // consigne moteur max
         else if (ValUS < 20)    // 20 cm
            Moteur = 0;          // Arret moteur
         else
            Moteur = (int8)(ValUS/5); // consigne en fonction de la distance

         // Vitesse hemisson proportionnelle  la distance de l'obstacle
   		hemisson_set_speed(Moteur, Moteur);
         // On allume les leds si on avance
         hemisson_led_frontright(Moteur > 0);
         hemisson_led_frontleft(Moteur > 0);
         }
      }
   else
      {
      hemisson_beep(1);		        // Buzzer On
		hemisson_delay_s(2);			  // Attendre 2s
      hemisson_beep(0);		        // Buzzer Off
      }
}
